#!/bin/sh

fluroot=/mnt/sd/fluroot
sdbusybox=/mnt/sd/fluroot/busybox
statelog=/www/statelog.txt
fluconfig=/mnt/sd/DCIM/122_TREK/fluconfig.txt

if [ -f $fluconfig ];
then
    . $fluconfig
fi

# direcotry creation
mkdir /usr/include
mkdir /usr/lib
mkdir /usr/libexec
mkdir /usr/local
mkdir /usr/local/bin
mkdir /usr/local/lib
mkdir /var/tmp/var/
chmod a+w /var/tmp/var

echo ""> $statelog

if [ "$ENABLETELNETD" = "yes" ];
then
    $sdbusybox killall telnetd
    sleep 1

    mount -t devpts /dev/pts
    $sdbusybox telnetd -l /bin/sh &
    sleep 3
    echo "enable telnetd" >> $statelog
fi

if [ "$REPLACEBUSYBOX" = "yes" ];
then
	ln -s $sdbusybox /bin/awk
	rm /bin/dd
	ln -s $sdbusybox /bin/dd
	ln -s $sdbusybox /bin/find
	ln -s $sdbusybox /bin/grep
	ln -s $sdbusybox /bin/hexdump
	ln -s $sdbusybox /bin/killall
	ln -s $sdbusybox /bin/less
	ln -s $sdbusybox /bin/passwd
	ln -s $sdbusybox /bin/sed
	ln -s $sdbusybox /bin/tar
	ln -s $sdbusybox /bin/tail
	ln -s $sdbusybox /bin/telnetd
	ln -s $sdbusybox /bin/watch
	ln -s $sdbusybox /bin/whoami
	echo "replace busybox " >> $statelog
fi

if [ "$INSTALLSHAREDLIB" = "yes" ];
then
    ln -s $fluroot/shared/lib/* /lib/
    echo "install shared lib" >> $statelog
fi

if [ "$INSTALLPERL" = "yes" ];
then
    ln -s $fluroot/perl/usr/bin/* /usr/bin/
    ln -s $fluroot/perl/usr/local/lib/* /usr/local/lib/
    echo "install perl" >> $statelog
fi

if [ "$INSTALLRUBY" = "yes" ];
then
    ln -s $fluroot/ruby/lib/* /lib/
    ln -s $fluroot/ruby/usr/bin/* /usr/bin/
    ln -s $fluroot/ruby/usr/include/* /usr/include/
    ln -s $fluroot/ruby/usr/lib/* /usr/lib/
    echo "install ruby" >> $statelog
fi

if [ "$INSTALLPHP" = "yes" ];
then
    ln -s $fluroot/php/etc/* /etc/
    ln -s $fluroot/php/bin/* /bin/
    echo "install ruby" >> $statelog
fi

if [ "$REPLACEFTPD" = "yes" ];
then
    rm /usr/sbin/ftpd
    ln -s $sdbusybox /usr/sbin/ftpd
    echo "replace ftpd" >> $statelog
fi

if [ "$REPLACETCPSVD" = "yes" ];
then
    rm /usr/bin/tcpsvd
    ln -s $sdbusybox /usr/bin/tcpsvd
    echo "replace tcpsvd" >> $statelog
fi

if [ "$REPLACEHTTPD" = "yes" ];
then
    $sdbusybox killall httpd
    sleep 1
    if [ -f /etc/httpd.conf ];
    then
    	$sdbusybox httpd -h /www -c /etc/httpd.conf&
    else
    	$sdbusybox httpd -h /www &
    fi
    echo "replace httpd" >> $statelog
fi

if [ "$ENABLEFTPD" = "yes" ];
then
    $sdbusybox tcpsvd 0.0.0.0 21 ftpd -w /&
    sleep 1
    echo "enable ftpd" >> $statelog
fi


if [ "$ENABLESSHD" = "yes" ];
then
    cp -r $fluroot/ssh/etc/* /etc/
    ln -s $fluroot/ssh/bin/* /bin/
    ln -s $fluroot/ssh/sbin/* /sbin/
    ln -s $fluroot/ssh/usr/libexec/* /usr/libexec/
    cp -r $fluroot/ssh/etc/* /etc/
    /sbin/dropbear -A -N root -C admin -U 0 -G 0
	sleep 1
    echo "enable sshd" >> $statelog
fi

if [ "$ENABLESSHD2" = "yes" ];
then
    cp -r $fluroot/ssh/etc/* /etc/
    cp $fluroot/ssh2/dropbearmulti /sbin/dropbearmulti
    ln -s /sbin/dropbearmulti /bin/dbclient
    ln -s /sbin/dropbearmulti /bin/dropbearconvert
    ln -s /sbin/dropbearmulti /bin/dropbearkey
    ln -s /sbin/dropbearmulti /bin/scp
    ln -s /sbin/dropbearmulti /bin/sftp
    ln -s /sbin/dropbearmulti /sbin/dropbear
    chmod u+s /sbin/dropbearmulti

    /sbin/dropbear
    sleep 1
    echo "enable sshd2" >> $statelog
fi


if [ "$ENABLEFLASHAIR" = "yes" ];
then
	cp $fluroot/flashair/www/* /www/
	cp $fluroot/flashair/etc/dnsd.conf /etc/
	cp $fluroot/flashair/etc/udhcpd_uap.conf /etc/
	ln -s $fluroot/flashair/bin/jhead /bin/
	
	if [ ! -f $fluroot/flashair/etc/config.trek.org ];
	then
		cp /mnt/mtd/config/config.trek  $fluroot/flashair/etc/config.trek.org
	fi
	if [ ! -f $fluroot/flashair/etc/config.trek.tmp ];
	then
		sed -e "s/192\.168\.1\.1/192\.168\.0\.1/g" /mnt/mtd/config/config.trek > $fluroot/flashair/etc/config.trek.tmp
	fi
	cp $fluroot/flashair/etc/config.trek.tmp /mnt/mtd/config/config.trek
	cp $fluroot/perl.sh /www/cgi-bin/perl.cgi
	for file in /mnt/sd/DCIM/*
	do
		if [ -d $file ];
		then
			echo $file
			/www/command.cgi $file > $file/index.html
		fi
	done
	/www/command.cgi >> /www/index.html
	
	echo "enable flashair compatible mode" >> $statelog
fi

mount >> $statelog
ps >> $statelog
perl -V >> $statelog
echo "=== /etc ===" >> $statelog
ls -lR /etc/ >> $statelog
echo "=== /www ===" >> $statelog
ls -lR /www/ >> $st